.section        ".text"
        .align 4
        .global modulo

modulo:                         ! modulo (a, b): reste (r) de la division
                                !                entire a / b
                                !       a = b.q + r
                                !  <=>  r = a - b.q
                                ! avec  q = a / b
        save %sp, -64, %sp

        mov %g0, %y             ! le premier oprande de udiv est sur 64 bits
        udiv %i0, %i1, %i2      ! %i2 <- q = a / b
        umul %i1, %i2, %i1      ! %i1 <- b.q
        sub %i0, %i1, %i0       ! %i0 <- r = a - b.q
        
        ret                     ! return %i0
        restore