.section        ".text"
        .align 4
        .global pgcd

pgcd:                           ! pgcd (%i0, %i1):  calcul du pgcd
        save %sp, -96, %sp
        
        cmp %i1, %g0            ! if (b != 0) {
        be .end_pgcd            !
        nop                     !
        
        mov %i0, %o0            !
        mov %i1, %o1            !
        call modulo             !       %o0 <- %i0 mod %i1
        nop                     !
        
        mov %o0, %o1            !
        mov %i1, %o0            !
        call pgcd               !       %o0 <- pgcd (%i1, %o0)
        nop                     !
        
        mov %o0, %i0            !       %i0 <- %o0
.end_pgcd:                      ! }
        ret                     ! return %i0
        restore
        
        
.section        ".rodata"
        .align 8
        
.INPUT_PRINTF:  
        .asciz "a b (a >= b)? "
        
.INPUT_SCANF:
        .asciz "%u %u"
        
.OUTPUT_PRINTF: 
        .asciz "pgcd(%u, %u) = %u\n"

        
.section        ".text"
        .align 4
        .global main

main:
        save %sp, -104, %sp     ! rserve de l'espace pour 2 variables locales

        set .INPUT_PRINTF, %o0
        call printf             ! printf (.INPUT_PRINTF)
        nop
        
        set .INPUT_SCANF, %o0
        add %fp, -4, %o1
        add %fp, -8, %o2
        call scanf              ! scanf (.INPUT_SCANF, %fp-4, ,%fp-8)
        nop
        
        ld [%fp-4], %o0        
        ld [%fp-8], %o1
        call pgcd               ! %o0 <- pgcd (*(%fp-4), *(%fp-8))
        nop
        
        mov %o0, %o3
        set .OUTPUT_PRINTF, %o0
        ld [%fp-4], %o1        
        ld [%fp-8], %o2
        call printf             ! printf (.OUTPUT_PRINTF, *(%fp-4), *(%fp-8), %o0)
        nop
        
        clr %i0
        ret                     ! return 0
        restore