
! Fonction addition
!       -> retourne la somme de ses deux arguments
!------------------------------------------------------------

.section        ".text"                 ! -> code
        .align 4                        !    align sur 4 octets
        .global add                     ! exporte le symbole  add 

add:
        save %sp,-64,%sp                ! rserve de l'espace sur la pile
        add %i0,%i1,%i0                 ! calcule la somme des paramtres,
                                        ! le rsultat est la valeur de retour
                                        ! de la fonction
        ret                             ! retour de la fonction add
        restore


! Programme principal
!------------------------------------------------------------

.section        ".data"                 ! -> donnes
        .align 8                        !    alignes sur 8 octets
.PRINTF1:
        .asciz  "Entrez a et b : "      ! chane de caractres avec zro
                                        ! terminal
.SCANF:
        .asciz  "%d %d"                 ! idem
.PRINTF2:
        .asciz  "c : %d\n"              ! idem
        
.section        ".text"                 ! -> code
        .align 4                        !    align sur 4 octets
        .global main                    ! exporte le symbole  main 

main:
        save %sp,-104,%sp               ! rserve de l'espace sur la pile:
                                        ! 96 + 8 octets pour deux variables 
                                        ! locale aux adresses %fp-4 et %fp-8
        
        ! printf
        sethi %hi(.PRINTF1),%o0         ! %o0 <- .PRINTF1
        or %o0,%lo(.PRINTF1),%o0
        call printf                     ! appel de  printf (.PRINTF1) 
        nop                             !  nop  aprs un  call 
        
        ! scanf
        add %fp,-4,%o1                  ! %o1 <- %fp-4
        add %fp,-8,%o2                  ! %o2 <- %fp-8
        sethi %hi(.SCANF),%o0           ! %o0 <- .SCANF
        or %o0,%lo(.SCANF),%o0
        call scanf                      ! appel de 
                                        !  scanf (.SCANF1, %fp-4, %fp-8) 
        nop                             !  nop  aprs un  call 
        
        ! addition 
        ld [%fp-4],%o0                  ! %o0 <- [%fp-4]
        ld [%fp-8],%o1                  ! %o1 <- [%fp-8]
        call add                        ! appel de  add ([%fp-4], [%fp-8]) 
                                        ! rsultat dans %o0
        nop                             !  nop  aprs un  call 
        
        ! printf
        mov %o0,%o1                     ! %o1 <- %o0
        sethi %hi(.PRINTF2),%o0         ! %o0 <- .PRINTF2
        or %o0,%lo(.PRINTF2),%o0
        call printf                     ! appel de  printf (.PRINTF2, %o0) 
        nop                             !  nop  aprs un  call 

        ret                             ! retour de la fonction  main
        restore