!!!
!!! calcul de la factorielle d'un entier, version itrative
!!!

! Programme principal
!------------------------------------------------------------

.section        ".data"                 ! -> donnes
        .align 8
.PRINTF1:
        .asciz  "n? "
.SCANF:
        .asciz  "%u"
.PRINTF2:
        .asciz "n! = %u\n"


.section        ".text"                 ! -> code
        .align 4
        .global main

main:
        save %sp, -96, %sp              ! rserve de la place sur la pile
                                        ! pour un entier [%fp-4] (mais on 
                                        ! arrondit  un multiple de 8)

        sethi %hi(.PRINTF1), %o0
        or %o0, %lo(.PRINTF1), %o0
        call printf                     ! printf (.PRINTF1)
        nop

        sethi %hi(.SCANF), %o0
        or %o0, %lo(.SCANF), %o0
        add %fp, -4, %o1
        call scanf                      ! scanf (.SCANF, %fp-4)
        nop
        
                                        ! -> calcul de [%fp-4]! dans %l1,
                                        !   utilisation de %l0 comme compteur

        ld [%fp-4], %l0                 ! %l0 <- [%fp-4]
        mov 1, %l1                      ! %l1 <- 1
loop:
        cmp %l0, 1                      ! while (%l0 > 1) {
        ble end_loop                    !
        nop                             !
        umul %l0, %l1, %l1              !     %l1 <- %l1 * %l0
        dec %l0                         !     %l0 --
        b loop                          ! }
        nop

end_loop:
        sethi %hi(.PRINTF2), %o0
        or %o0, %lo(.PRINTF2), %o0
        mov %l1, %o1
        call printf                     ! printf (.PRINTF2, %l1)
        nop
        
        clr %i0                         ! return 0
        ret
        restore