!!!
!!! calcul de la factorielle d'un entier, version rcursive,
!!! affichage de %fp et %sp
!!!

! fonction fact
!       -> retourne la factorielle de son argument
!------------------------------------------------------------

.section        ".data"                 ! -> donnes
        .align 8
.PRINTF_DEBUG:
        .asciz "# fact (%u): %%fp = %p, %%sp = %p\n"

.section        ".text"                 ! -> code
        .align 4
        .global fact

fact:
        save %sp, -96, %sp

        sethi %hi(.PRINTF_DEBUG), %o0
        or %o0, %lo(.PRINTF_DEBUG), %o0
        mov %i0, %o1
        mov %fp, %o2
        mov %sp, %o3
        call printf                     ! printf (.PRINTF_DEBUG, 
                                        !         %i0, %fp, %sp)
        nop     

        cmp %i0, 1                      ! if (%i0 > 1) {
        ble end_fact1                   !
        nop                             !
        sub %i0, 1, %o0                 !     %o0 <- %i0 - 1
        call fact                       !     %o0 <- fact (%o0)
        nop                             !
        umul %i0, %o0, %i0              !     %i0 <- %o0 * %i0
        b end_fact                      ! } else {
        nop                             !
end_fact1:                              !
        mov 1, %i0                      !     %i0 <- 1
                                        ! }
end_fact:
        ret                             ! return %i0
        restore


! Programme principal
!------------------------------------------------------------

.section        ".data"                 ! -> donnes
        .align 8
.PRINTF1:
        .asciz  "n? "
.SCANF:
        .asciz  "%u"
.PRINTF2:
        .asciz "n! = %u\n"

.section        ".text"                 ! -> code
        .align 4
        .global main

main:
        save %sp, -96, %sp              ! rserve de la place sur la pile
                                        ! pour un entier [%fp-4] (mais on 
                                        ! arrondit  un multiple de 8)

        sethi %hi(.PRINTF1), %o0
        or %o0, %lo(.PRINTF1), %o0
        call printf                     ! printf (.PRINTF1)
        nop

        sethi %hi(.SCANF), %o0
        or %o0, %lo(.SCANF), %o0
        add %fp, -4, %o1
        call scanf                      ! scanf (.SCANF, %fp-4)
        nop
        
        ld [%fp-4], %o0
        call fact                       ! %o0 <- fact ([%fp-4])
        nop

        mov %o0, %o1
        sethi %hi(.PRINTF2), %o0
        or %o0, %lo(.PRINTF2), %o0
        call printf                     ! printf (.PRINTF2, %o0)
        nop
        
        clr %i0                         ! return 0
        ret
        restore