!!!
!!! recherche du minimum dans un tableau
!!!

! Fonction min: recherche du minimum dans un tableau d'entiers
!       2 arguments: adresse du tableau et nombre d'lments
!       retourne l'indice du minimum dans le tableau
!       prcondition: la tableau contient au moins 1 lment
!------------------------------------------------------------

.section        ".text"                         ! -> code
        .align 4
        .global min

min:
        save %sp, -64, %sp
                                                ! registres locaux utiliss:
                                                ! %l0: index du min. courant
                                                ! %l1: minimum courant
                                                ! %l2: index courant
                                                ! %l3: valeur courante

        clr %l0                                 ! %l0 <- 0
        ld [%i0], %l1                           ! %l1 <- tab[0]
        clr %l2                                 ! %l2 <- 0
        orcc %i1, %g0, %g0
min_loop:                                       ! while (%i1 != 0) {
        bz end_min                              !
        nop                                     !
        inc %l2                                 !     %l2 ++
        add %i0, 4, %i0                         !     %i0 <- %i0 
                                                !            + sizeof(int)
        ld [%i0], %l3                           !     %l3 <- tab[%l2]
        cmp %l1, %l3                            !     if (%l1 > %l3) {
        ble min_ok                              !
        nop                                     !
        mov %l2, %l0                            !         %l0 <- %l2
        mov %l3, %l1                            !         %l1 <- %l3
min_ok:                                         !     }
        deccc %i1                               !     %i1 --
        b min_loop                              ! }
        nop

end_min:
        mov %l0, %i0                            ! return %l0
        ret
        restore


! Programme principal
!       -> lit 10 entiers et trouve le minimum
!------------------------------------------------------------

.section        ".data"                         ! -> donnes
        .align 8
.PRINTF1:
        .asciz "Entrez 10 entiers:\n"
.SCANF:
        .asciz "%d"
.PRINTF2:
        .asciz "minimum: [%d] = %d\n"


.section        ".text"                         ! -> code
        .align 4
        .global main

main:
        save %sp, -136, %sp                     ! rserve de la place pour un 
                                                ! tableau de 10 entiers  
                                                ! l'adresse %fp-40
        set .PRINTF1, %o0
        call printf                             ! printf (.PRINTF1)
        nop

                                                ! lecture des entiers
        mov 10, %l0                             ! %l0 <- 10 (nombre d'entiers 
                                                !             lire)
        sub %fp, 40, %l1                        ! %l1 <- %fp-40 (adresse du 
                                                !                tableau)
read_loop:                                      ! do {
        set .SCANF, %o0                         !
        mov %l1, %o1                            !
        call scanf                              !     scanf (.SCANF, %l1)
        nop                                     !
        add %l1, 4, %l1                         !     %l1 <- %l1 
                                                !            + sizeof (int)
        deccc %l0                               !     %l0 --
        bnz read_loop                           ! } while (%l0 != 0)
        nop

                                                ! calcul du minimum
        sub %fp, 40, %o0                        ! %o0 <- %fp-40 (adresse du
                                                !                tableau)
        mov 10, %o1                             ! %o1 <- 10 (taille du
                                                !            tableau)
        call min                                ! %o0 <- min (%o0, %o1)
        nop
        
                                                ! affichage du rsultat
        mov %o0, %o1                            ! %o1 <- %o0 (indice du min.)
        sll %o0, 2, %o0                         ! %o0 <- %o0 * 4 
                                                !        (4 == sizeof (int))
        sub %o0, 40, %o0                        ! %o0 <- %o0 - 40
        ld [%fp+%o0], %o2                       ! %o2 <- [%fp+%o0] (tab[%o1], 
                                                !             valeur du min.)
        set .PRINTF2, %o0
        call printf                             ! printf (.PRINTF2,
                                                !         indice_du_min,
                                                !         valeur_du_min)
        nop

        clr %i0                                 ! return 0
        ret
        restore