;       Donnes places en mmoire  l'adresse 0 
; .word introduit des entiers signs, pour les autres types, on utilise
; .float, .double, .byte

.data 0
.word 6, 1, 9, 6, -14, 11, 2
.space 4
.space 4

;       Instructions places en mmoire  l'adresse 256 (par dfaut)

.text
_main:  xor r1, r1, r1          ; r1: pointeur <- 0
        lw r2, 0(r1)            ; r2: compteur <- *r1
        addi r1, r1, 4          ; r1 ++
        subi r2, r2, 1          ; r2 --
        lw r3, 0(r1)            ; r3: min <- *r1
        lw r4, 0(r1)            ; r4: max <- *r1

loop:   
        beqz r2, end_loop       ; while (r2 != 0)
        addi r1, r1, 4          ;       r1 ++ (delay slot)

        lw r5, 0(r1)            ;       r5 <- *r1
        subi r2, r2, 1          ;       r2 --
        slt r6, r5, r3          ;       r6 <- (r5 < min)
        sgt r7, r5, r4          ;       r7 <- (r5 > max)
        beqz r6, notmin         ;       if (r6) {
        nop
        j loop                  ;               continue
        ori r3, r5, 0           ;               min <- r5 (delay slot)
notmin:                         ;       } else if (! r7) {
        beqz r7, loop           ;               continue
        nop                     ;       } else {
        j loop                  ;               continue
        ori r4, r5, 0           ;               max <- val (delay slot)
                                ;       }
                                ; }
end_loop:                       ; }
        sw 0(r1), r3            ; *r1 <- min
        addi r1, r1, 4          ; r1 ++
        sw 0(r1), r4            ; *r1 <- max
        trap 0

; trap 0 provoque la sortie du programme, sans cela, le programme
; excuterait  l'infini des instructions nop