;       Donnes places en mmoire  l'adresse 0 
; .word introduit des entiers signs, pour les autres types, on
; utilise .float, .double, .byte 

.data 0
.word 6, 1, 9, 6, -14, 11, 2
.space 4
.space 4

;       Instructions places en mmoire  l'adresse 256 (par dfaut)

.text
_main:  xor r1, r1, r1          ; r1: pointeur <- 0
        lw r2, 0(r1)            ; r2: compteur <- *r1
        addi r1, r1, 4          ; r1 ++
        lw r3, 0(r1)            ; r3: min <- *r1
        lw r4, 0(r1)            ; r4: max <- *r1

loop:   
        subi r2, r2, 1          ; while (-- r2 != 0) {
        beqz r2, end_loop       
        nop 

        addi r1, r1, 4          ;       r1 ++
        lw r5, 0(r1)            ;       r5 <- *r1
        slt r6, r5, r3          ;       if (r5 < min) {
        beqz r6, notmin
        nop
        ori r3, r5, 0           ;               min <- r5
        j loop                  ;               continue
        nop
notmin: 
        sgt r6, r5, r4          ;       } else if (! (r5 > max)) {
        beqz r6, loop           ;               continue
        nop                     ;       } else {
        ori r4, r5, 0           ;               max <- r5
        j loop                  ;               continue
        nop                     ;       }
                                ; }
end_loop:
        addi r1, r1, 4          ; r1 ++
        sw 0(r1), r3            ; *r1 <- min
        addi r1, r1, 4          ; r1 ++
        sw 0(r1), r4            ; *r1 <- max
        trap 0

; trap 0 provoque la sortie du programme, sans cela, le programme
;       excuterait  l'infini des instructions nop